S - n a i l / S - m a i l x  N e w s
====================================

  mdocmx(7) anchors are denoted by a number-sign #: typing
  "^A ANCHOR" while reading the man(1)ual in a capable less(1)
  will scroll to the manual's Point-Of-Interest, and pointing
  a web- browser to the "#ANCHOR" of the online manual works.

v14.9.11 ("Tit family enjoying a bath"), 2018-08-08
---------------------------------------------------

A hot summer bugfix release, but it surely brings in some new
features, like TLS fingerprinting and `digmsg' message access.

An embarassing number of bugfixes have been seen, to fix IMAP UID
handling on 32-bit hosts, UTF-8, `readall' with empty lines, rare
endless iconv(3) loops, false qsort(3)ing of addressee lists,
crashes due to false user shell quoting, acceptance of "0" port
numbers, and more.  Most of these cases now have tests.

Credits, in order of commit appearance: Paride Legovini,
Andrew Gee, Olav Mørkrid, Kevin McCarthy, Michael Dressel,
Jürgen Bruckner, Robert Elz, Rudolf Sykora, Doug McIlroy,
Gavin Troy and Jörg Schilling.
A special credit to Coverity.com again, it found a bug!
(https://scan.coverity.com/projects/s-nail, project number 444.)

We welcome Andrew Gee, Kevin McCarthy, Michael Dressel,
Olav Mørkrid and Jürgen Bruckner in THANKS.

NOTES, ChangeLog (packager-affine)
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

- I have discovered that GnuPG can --export-secret-subkey so that
  the real/full private key is no longer needed to --sign, and the
  excerpts of the private one can have a different password, too.
  So i have created a new for-signing subkey: EEC8C2FF.

  Unfortunately it is not possible to verify new signatures with
  the old public key, an update is necessary.  For example via
    https://ftp.sdaoden.eu/steffen.asc
  or just update 1883A0DD via normal gpg(1).

- Maildir support is now optional but default via OPT_MAILDIR.
  (Paride Legovini)

- I hope for the last time there has been a change to SSL
  configuration: i have renamed all ssl* variables to tls*.
  The old ssl* ones still exist until v15, though, yet obsoletion
  warnings will be produced.
  This is so because i expect that in a not too distant future
  only the term TLS will be around.

  Also the term CipherList was falsely used, it should have been
  CipherString.

- Most (if not all) commands which take a message list and a file
  target now use shell-style quoting.  (Before that say `copy'#157
  scanned backwards over "something possibly quoted", took that
  off, then treated the rest as a message list.  Now shell tokens
  are parsed starting at the front, the last is taken off, and
  anything before that is the message list.)  (Gavin Troy.  2013.)

- `~^#? header show' now optionally show the address type in
  field 1.  This is backward-incompatible but _only_ applies to
  non-network addresses.

- We will find ncurses on DragonFly BSD.

- On Solaris tests no longer need GNU cksum(1): the Solaris cksum
  is different only for whitespace separators.  (Jörg Schilling)

- Any generated files reside in .obj/, and the tests run in there,
  too.  A "rm -f .obj" should suffice to clean anything up.  Fast.

ChangeLog
^^^^^^^^^

- `~F'#318, `~f'#319, `~M'#324, `~m'#325, `~U'#333 and `~u'#334
  now default to the current message (the "dot").  (Andrew Gee)

- *indentprefix*#428 handling has had its pitfalls when quoting
  messages.  (Andrew Gee)

- -r#76 will again set *from*#410 even after -S#77 has been used
  to set *from*.  (Michael Dressel)

- No longer process From: (*from*#410) content via alternates
  when Sender: (*sender*#510) is set.  (Michael Dressel)

- Because the priority class of headers was not taken into
  account, it could happen that addressees in Cc: would remain but
  the same in To: were removed.  (Michael Dressel)

- IMAP accounts for RFC 4551 (and 7162) and supports 64-bit
  UIDVALIDITY.

- *spamfilter-rate-scanscore*#546 could crash if specification
  did not match program output.

- Shims for TLSv1.3 support, e.g., for *tls-config-pairs*#558.

- Obsoleted *dotlock-ignore-error*, added *dotlock-disable*#392.
  (Paride Legovini)

- In compose-mode, removing the In-Reply-To: header breaks an old,
  and starts a new thread.  (Doug McIlroy)

- Added new *forward-inject-tail*#409, *quote-inject-head*#493
  and *quote-inject-tail* variables, and extended the meaning
  of *quote*#489.

  All of *{forward,quote}-inject-{head,tail}* now support
  a compose-mode specific set of formats (see
  *quote-inject-head*#493), for now a few only.
  (This adds meaning onto the content of *forward-inject-head*#408
  as introduced in v14.9.0.)

  The generated output honours *quote-fold*#492, which now takes
  an optional third argument in order to produce better output.

  While here, introduce the new command escape `~Q'#327 which
  performs full *quote*#489 cycles on the given message list.

- Fcc: headers are now understood in -t#79 templates or when
  placed in compose mode (`~v'#335, *editalong*#393 etc.).
  Since each such header only takes one addressee, no quoting
  issues apply, the entire header body is the value.

- `~|'#310 will pass the entire message including headers when
  used as "~||", e.g., prepend a file-carbon-copy message header:

    ~|| echo Fcc: /tmp/test; cat

- New `tls'#280 multiplexer command.  Yet primitive and only
  supports a `fingerprint' subcommand.  Supports `vput'#121.

  The new *tls-fingerprint*#562 variable chain aids in adding
  support for connection verification without an installed CA
  certificate pool in conjunction with the new
  *tls-fingerprint-digest*#563 chain.

  Consequently *smime-sign-message-digest* has been renamed to
  *smime-sign-digest*#530 (old version will cease in v15).
  The latter now defaults to SHA512 if possible.

- New MLE commands mle-go-screen-bwd and mle-go-screen-fwd to go
  backward and forward one screenful.
  And a new mle-clear-screen command.  (Todd C. Miller)

- New *expandaddr*#398 setting "shquote" will evaluate addresses
  as if specified within $'' shell-quotes for -b#57, -c#59,
  and all direct command line receivers.  This allows for, e.g.,

    $ s-nail -Sexpandaddr=shquote '\$contact-mail'

- *quote-as-attachment*#490 no longer needs to be set before
  compose mode is entered in order to become honoured.

- Even for -H#66 or -L#69 *folder-hook*#403s will now be called.
  Possible sorting is also applied.

- `='#129 now optionally supports message list arguments and the
  `vput'#121 modifier in order to store the result list.

  The new `digmsg'#165 multiplexer adds some message access, just
  like `~^'#311 does in compose mode.  In fact the set of commands
  is shared, yet `digmsg' is only read-only and cannot access
  attachments until v15, however.  For example,

  ?0[steffen@essex nail.git]$ cat > /tmp/z.rc <<'_EOT'
  define one {
     if [ "${#}" -gt 0 ]
        digmsg create $1 - # no `read'/`readall' overlay but stdout
        #digmsg $1 header list
        digmsg $1 header show subject
        digmsg remove $1
        shift
        \eval xcall one "$@"
     \end
  }
  define all {
     local set all # localize this (localopts yes would do too)
     vput = all *
     echo all: $all
     eval call one $all
  }
_EOT
  ?0[steffen@essex nail.git]$ MAILRC=/tmp/z.rc \
    .obj/s-nail -:u -Snoheader -Squiet -Rf /tmp/z
  ? call all
  all: 1 2 3
  212 Subject
  Re: [S-mailx] FYI: after USB stick loss i have rotated keys, plus

  212 Subject
  Re: Problem with page?

  212 Subject
  Re: s-nail Source ...

  ? x

git(1) shortlog (edited)
^^^^^^^^^^^^^^^^^^^^^^^^

Steffen Nurpmeso (203):
81e5960e nail.1, nail.rc: fix spelling (Paride Legovini)
bde9329f FIX hasty [ab7aab0e] (Account for drafted 64-bit IMAP UIDs..)..
5169d3ba collect(): ~[FfMmUu]: should default to the "dot" (Andrew Gee)
068d202d THANKS: Andrew Gee
662d9762 send.c:sendpart(): fix *indentprefix* handling for SEND_QUOTE (Andrew
        Gee)
ca61f59a Elder groff mdoc do not have str-Lb-libterminfo (Olav Mørkrid)
a234b4ec GSSAPI: fix gss_buffer_desc usage (since EVER!) (Kevin McCarthy)..
89fc94e7 THANKS: Kevin McCarthy
4c67719c makefile: do not "exit 1" in __prestop, exit 0 instead (Paride
        Legovini)
2978064a nail.1: clarify MBOX locking strategy (Paride Legovini)
0994c919 n_utf8_to_utf32(): FIX extending cast, broken in [5f951f7b] (on
        2018-01-09!)
92c49370 n_iconv_str(): FIX possible endless loop due to insufficient growth
12216988 Fix: allow -r to set from after -Sfrom= (Michael Dressel)..
8a5a123c THANKS: Michael Dressel
c1737baf Do not process From: alternates if Sender: is set (Michael Dressel)..
9e101e33 a_nag_elide_qsort(): FIX false sorting (Michael Dressel)..
b6bc7c4e THANKS: Olav Mørkrid
094689b0 quoteflt_dummy() usage: FIX usage without preceeding _reset() (Jürgen
        Bruckner)
79717b95 THANKS: Jürgen Bruckner
bfca0fae IMAP: account for RFC 4551 (and 7162): support 64-bit UIDVALIDITY
4ed7448b resend_msg(): FIX: actually honour delayed errors!
9408d084 _spamfilter_interact(): FIX: *spamfilter-rate-scanscore* could cause
        crashes..
a94e7323 a_cmisc_echo(): for `echoerr', ensure *log-prefix* is placed
8412796a n_cmd_arg_parse(): FIX token error -> crash, e.g. "-RX 'bind;echo $?'
        -Xx"..
b4c80a76 c_readall(): FIX handling of empty lines (with test)
12969c7a Add shims to support TLSv1.3 via OpenSSL
a6bd8490 Add notes on (yet) impossible fullfillment of user glob desires
        (Robert Elz)
bbc1b6b2 Now with `wysh set', obsolete `varedit'
f4c83d11 Truly support timeout on connect(2)s (Olav Mørkrid)
dbdf875c nail.1: *ssl-ca-dir* requires special preparation (Olav Mørkrid)
7fde1386 cc-test.sh: add t_behave_quote_a_cmd_escapes() (Andrew Gee)
7f32bdc4 make.rc,make-config.sh: add OPT_USAN (UndefinedBehaviorSanitizer)
ea358268 ok_b_ssl_no_default_ca: forgot to make that obsolete! (Olav Mørkrid)
2748ee6a a_main_getopt(): treat --version as -V
bf3185a7 Drop $OSENV; instead stuff for *verbose* `version' (Paride Legovini)
0f48cacd cc-test.sh: --check-only: keep files on err if in a repo (Paride
        Legovini)
165f6c10 Some: fix loosing->losing typo (Paride Legovini)
d363bd86 nail.1: (re)add doc. on PKCS#12 Cert/Key bundles (Rudolf Sykora)
4602b425 nail.1: (re)add s_client certificate fetch (Olav Mørkrid)
f1b42535 Obsolete *dotlock-ignore-error*, add *dotlock-disable* (Paride
        Legovini)
083306aa Add OPT_MAILDIR, by default enabled (Paride Legovini)
d4696774 In compose-mode, removing In-Reply-To: starts thread (Doug McIlroy)..
7869c1c4 Support "#." message attachment <> the "dot"
a0bce049 Add *forward-inject-tail*, *quote-inject-{head,tail}*, `~Q'..
d7ec16ec *quote-fold*: add optional third argument to improve break algo
e4a8ad28 make-release.txt: new signing OpenPGP subkey
0065d878 Fix: allow -r to set from after -Sfrom=, II. (Michael Dressel)..
6aa3e44a Do not process From: alternates if Sender: is set, II (Michael
        Dressel)
10cdea44 a_nag_elide_qsort(): FIX false sorting, II (Michael Dressel)[..]
3e0fa398 Fix (BWDIC!) `~^ header show': optionally show address type in field
        1..
83f0ebaa Support Fcc: headers in -t'emplates and editor..
8961182f `edit',`visual': do allow multiple edits in non-interactive mode
5651b570 Add header editing for new `~||' (`~|' + |)
3a68df5a a_sendout_attach_msg(): MIME for Content-Description:!
3f85801e ([BWDIC!]) Big notational warp of SSL to TLS; drop rand EGD support
bc2e369d Add `tls' command..
059e5541 Add *tls-fingerprint-digest*;
        *smime-sign-message-digest*->*smime-sign-digest*
a0efe35a MLE: add mle-go-screen-bwd and mle-go-screen-fwd
23c1adaa Add *tls-fingerprint* chain for CA-less connection verifications
7369013a MLE: add mle-clear-screen command (Todd C. Miller)..
c065b8c6 (BWDIC!) Add support for BLAKE2* and SHA3-* MDigests..
c00022e6 -b,-c,to-addr: support "as-if $''" via *expandaddr*=shquote
c1ae14f0 (BWDIC!) n_msglist(): warp to shell quoting rules!
f0e3b59e (BWDIC!) For -H and -L: call folder hook, (sort)++
aaf632a5 Drop laststring()! (Gavin Troy; in December 2013!)
6301c5f2 *quote-as-attachment*: handle in compose-mode, very last..
52dfe017 With *posix* honour `alternates' only for replies/aliases (Michael
        Dressel)
dee9c247 Solaris: native cksum(1) works with WS strip via sed(1) (Jörg
        Schilling)!
ab0313ff `=': support `vput' and an optional <msglist> argument
e92385e3 Add `digmsg', a yet primitive "message info digger"

v14.9.10 ("(40th Mail anniversary) Blue tit"), 2018-03-25
---------------------------------------------------------

On this day in 1978 Kurt Shoens placed the following comment in
def.h (now it is in nail.h):

  /*
   * Mail -- a mail program
   *
   * Author: Kurt Shoens (UCB) March 25, 1978
   */

v14.9.10 is mostly a stability and bugfix release.
It has seen a full test series including Coverity.com scans.
It fixes bugs i have introduced (also a double free in IMAP cache
that i introduced for v14.9.* series to address Coverity CID
1376978..).

In the end i am saying thanks to Gunnar Ritter for the IMAP
module, and absolutely especially his really neat idea of an IMAP
cache including offline work queue.  (IMAP will nonetheless
temporarily go in v15, but these ideas will come back thereafter.)
I have gray hairs now.

Credits, in order of commit appearance: William Yodlowsky,
Stuart Henderson, Jörg Schilling, Viktor SZÉPE, Rich Felker,
Ralph Corderoy and Philipp Gesang.

A special credit to Coverity.com again.  Because:
    tcc is 618496 bytes, pcc is 851968+24576 bytes,
    but gcc is 73355264 bytes and clang is even
    147406848 bytes, i wonder why the latter two never
    said a word that would have addressed the pretty
    obvious CID 1387053!
    [Use of initialized value, the author.]

We welcome Stuart Henderson and Philipp Gesang in THANKS.

NOTES, ChangeLog (packager-affine)
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

- The balls are now build with umask 0022 not 0027.
  (William Yodlowsky, Stuart Henderson)

- One actual development of this version was the addition of
  multiple choice VAL_ues, as documented in make.rc.
  For now we have VAL_IDNA (for OPT_IDNA)
    VAL_IDNA="idnkit idn2 idn"
  and VAL_RANDOM (by itself)
    VAL_RANDOM="arc4 ssl libgetrandom sysgetrandom urandom builtin"
  (Stuart Henderson)

  In brief:
    The value is interpreted as a whitespace separated list of
    strings, like "idn2 idn idnkit", case is ignored, order is
    important.
    The special strings "all" and "any" as well as the empty value
    are wildcard matches; if any entry in the list is a wildcard
    match, the rest of the list is ignored.

    The special string "error" will abort configuration once its
    list position is reached; this is only supported if
    documented, and not with an accompanying OPT_ (which then
    offers "require", as below).

  Since this VAL_RANDOM approach is so much better i have dropped
  OPT_SSL_RANDOM and OPT_NOEXTRANDOM that were recently
  introduced again.  They were c..p.

- Support for idnkit 2.3 has been added.
  Support for idnkit 1 (especially as idnkitlite) has been fixed.

- For the first time this codebase should be able to handle
  invalid MBOX mailboxes (produced by, e.g., dma(1)) gracefully.
  I hope i have found all places (sic) where code has to be fixed.
  E.g., "? copy * INVALID-MBOX" now works.
  (Smalltalk already knew objects which know what they are doing
  are for the better...  This is v15, then.)

- P.S.: the two FreeBSD test failures are noted in INSTALL.

ChangeLog
^^^^^^^^^

- *asksend*#357 will now really allow recomposing.

- `help'#203 now supports recursive `commandalias'#154es, and
  command self-recursion detection now works differently, it has
  been false for something like

      commandalias x q; commandalias q echo au

  since q became expanded to `quit'#238 (alias expansion equals
  new command word).  New behaviour: we allow equals once:

    commandalias q q; commandalias x q; x
  ->
    x -> q -> q -> quit

- *editalong*#393 can have a value, say "set editalong=v" and it
  will startup $VISUAL#604 not $EDITOR#582.

- Path separators are now normalized, thus all places, including
  MLE tab-expansion ("On terminal control and line editor"#17),
  can expand something like "///t*////t*".

- -E#62 flag will not be obsoleted.
  -D#60 flag has been reintroduced (sets *disconnected*#629 right
  away, was not reinstantiated with the rest of the IMAP support.)

git(1) shortlog: Steffen Nurpmeso (71)

v14.9.9 ("Marsh tit savours first spring sun, II") 2018-03-06
-------------------------------------------------------------

A bugfix release.
I hope with this the fallout of the Christmas 2016 "address the
Dr. Problem workshop" has been fully resolved and thus MIME for
header address fields, even if iconv(3) is involved, been fully
restored!  We have even more tests for this now.

The release v14.9.8 was broken on big endian machines.
I will remove the v14.9.8 balls from the server by the weekend.
Sorry for the inconvenience!

Credits, in order of commit appearance: Slavko, Matej Mužila,
Rich Felker, Simon McVittie, Paride Legovini, Cág,
Predrag Punosevac.

We welcome Slavko, Matej Mužila, Rich Felker and Simon McVittie in
THANKS.

NOTES, ChangeLog (packager-affine)
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

- The v14.9.* series called *pipe-TYPE/SUBTYPE*#471 handlers in
  display or quote mode with CR (carriage-return) bytes stripped
  because of a missing output file comparison check, which broke
  binary formats etc.  (Slavko)

- We now have native support for Libidn2.  (Matej Mužila)

- uname(1) is now hookable by setting the shell variable uname
  when calling make ("uname=MY-UNAME make config" etc.).
  (Simon McVittie)

  We no longer bake the kernel version into the binary, and
  `version'#293 includes uname(2) output.
  (Simon McVittie, Paride Legovini)

- We now support a fallback P(seudo)R(andomNumber)G(enerator)
  initialization even if getrandom(2)/getrandom(3) has been found
  by the configuration, just like we do for "/dev/urandom" usage.
  This does not affect systems with arc4random(3) or OpenSSL
  random usage.  (David Čepelík, Simon McVittie)

  A new OPT_SSL_RANDOM make.rc variable, by default initialized to
  the value of OPT_SSL.

ChangeLog
^^^^^^^^^

- `~@'#309 list-edit behaviour in -##85 batch mode was broken.

- Character set names will now undergo generic normalization,
  including stripping of iconv(3) //SUFFIXes.

git(1) shortlog: Steffen Nurpmeso (33)

v14.9.7 ("Marsh tit patiently scraping bark") 2018-02-16
--------------------------------------------------------

A maintenance release which fixes bugs and brings in features.

Credits, in order of commit appearance: Alexander Harm,
Viktor SZÉPE, Paul Eggert, Joseph Bisch, Paride Legovini,
and Peter J. Holzer.
A special credit to the disappearing mutt(1) bug tracker.
And to Gmane.org for creating gmane.mail.s-mailx.general!

Thanks Paride Legovini for becoming maintainer of the Debian port.

We welcome Joseph Bisch, Paride Legovini, and Peter J. Holzer in
THANKS.

NOTES, ChangeLog (packager-affine)
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

- The USB stick loss reported for v14.9.6 was fake news, so to
  say, the stick exists and therefore the old key is not
  compromised.

- We are back at Gmane.org!
    news.gmane.org/gmane.mail.s-mailx.general

- `history'#204 has learned to be context-sensitive a bit, and
  has two new subcommands, `load' and `save'.

    This is in parts backward incompatible because it needs a new
    *history-file*#416 format; however, the old format can be loaded
    yet compose-mode commands will not appear in compose mode no
    more.  Iirc you can start with an old format then `save' to
    the new, then replace the "d" in the first column with "c" for
    compose-mode commands which should appear correctly.

- Obsoletion warnings for variables now happen at `set'#260
  time instead of when used.  Running once via -v#82 may
  be beneficial.

- The saturation modifier of `vexpr'#294 is henceforth a prefix,
  the suffix version is obsolete (but still supported for a while).

- A network address that contains no domain-, but only a valid local
  user <name> in angle brackets will be automatically expanded to
  a valid address when *hostname*#421 is set to a non-empty value;
  setting it to the empty value instructs us that the used *mta*#450
  (including builtin SMTP) will perform the necessary expansion.
  (Viktor SZÉPE)

  Note that *hostname*#421 as well as *smtp-hostname*#533
  will now undergo IDNA expansion if IDNA is supported.

  And *from*#410 and *sender*#510 are now verified at `set'#260
  time, not when used.  (Viktor SZÉPE)

- The commit message in [d503bd82] is wrong, apologies to
  Paride Legovini.  The test(1) operator "-n" appeared in Seventh
  Edition UNIX, not V8 as falsely claimed.

ChangeLog
^^^^^^^^^

- Our `addrcodec'#134 parser chokes on lesser constructs.

- Presence of command-line MTA arguments without *expandargv*#399
  are now a hard error.  It was my fault that this was not the
  default from the very start.  (Viktor SZÉPE)

- Seen on the mutt bug tracker, we also still have had problems
  with time settings that cross 32-bit boundaries.  As that is
  in parts induced by the C standard, now implement those parts on
  our own, and be super careful in general.  (Joseph Bisch)

- The `~@'#309 command escape did not shell-unquote the user input
  again and was thus a bit broken; message attachments also work
  again.

- Support custom headers from the command line via -C#58.
  And *customhdr*#386 is verified upon `set'#260 time.

- The simple builtin HTML viewer now supports <blockquote>
  elements, which many web mailers, most notably gmail, use for
  citation.  (Peter J. Holzer)

git(1) shortlog: Paride Legovini (1), Steffen Nurpmeso (66)

v14.9.6 ("Marsh tit abiding a snow storm"), 2017-12-05
------------------------------------------------------

A bugfix release which fixes four serious and three other bugs.
A few new features came in, too.

Many thanks go to Ralph Corderoy who reported an issue that was
caused by a terrible, terrible word reversal that i managed to
produce in December 2016, and which caused the v14.9.x series to
not MIME encode (non-address) content of address header fields!

Credits, in order of commit appearance: Thomas Dickey,
Andreas Baumann, Erich Eckner, Gaetan Bisson, Solar Designer, Cág,
Ivan Tham, Ralph Corderoy and Doug McIlroy.

We welcome Andreas Baumann, Erich Eckner, Solar Designer and Cág
in THANKS.

NOTES, ChangeLog (packager-affine)
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

- After USB stick loss the authors OpenPGP key has been switched to

    pub   4096R/1883A0DD 2017-11-30 [expires: 2027-11-28]
          Key fingerprint =
            EE19 E1C1 F2F7 054F 8D39  54D8 3089 64B5 1883 A0DD
    uid                  Steffen Nurpmeso <steffen@sdaoden.eu>

- $TMPDIR#602 no longer honoured for root runs.  (Solar Designer)

- *mime-encoding*#448 defaults to quoted-printable again.  (Cág)

- We _can_ MIME encode even header fields which contain addresses.
  Thanks to Ralph Corderoy we now also _do_ so again!

ChangeLog
^^^^^^^^^

- ***#336 now uses *ifs*#423 when splitting.

- Freezing *ttycharset*#568 via -S#77 also survives using or
  setting any of $LC_ALL#584, $LC_CTYPE#585 and $LANG#586 during
  program startup.

- New `local'#118 command modifier to localize changes.
  Yet supported only for `set'#260, i.e., we have gained
  macro-local variables.

- `vexpr'#294 now supports a BASE#number notation for integers,
  like 16#AFFE as an alternative to 0xAFFE.

  Hint: variable settings can most often use several bases, too,
  e.g., i have "set mime-counter-evidence=0b1111".

- Very simple form of *quote-chars*#491 to adjust our knowledge of
  what actually is to be treated as a quote character.

- *mime-counter-evidence*#447 deep inspection (bit four) has
  been improved for the sole cases of quoting or displaying
  a message.  So messages with less than 25% of control characters
  and such will now be displayed (made printable).  This is yet
  not configurable nor do we have a way to easily access a message
  with more than that.  (Doug McIlroy)

git(1) shortlog: Steffen Nurpmeso (44)

v14.9.5 ("Marsh tit engaged with a peanut"), 2017-10-21
-------------------------------------------------------

A bugfix release which fixes two bugs which were cast in stone.
A few compatibility improvements (AlpineLinux, Solaris).
And minor features.

Apologies to Jörg Schilling, a git bug i think it was who caused
joining of changesets, losing a credit, and it had been pushed to
[master] before the problem was realized.

Credits, in order of commit appearance: Jörg Schilling,
Doug McIlroy, Random832, Nick Stoughton and Ivan Tham.

We welcome Nick Stoughton and Ivan Tham in THANKS.

NOTES, ChangeLog (packager-affine)
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

- New OPT_USE_PKGSYS option can be disabled to not automatically
  pick known package system paths (pkg(7), OpenCSW, schily).
  (Jörg Schilling)

ChangeLog
^^^^^^^^^

- The software indeed _never_ dealt with iconv(3) output character
  set errors (as opposed to invalid input character set byte
  sequences etc.) for the main message body!
  And I have missed that when i tweaked our iconv layer a bit!

- Fixed a race condition with sigsuspend(2) that i could only see
  on OpenBSD.  config.h offers n_SIGSUSPEND_NOT_WAITPID, by the
  way, which saves some systemcalls and did not run races, but
  noone adjusts this file.

- Message list specifications gained two new colon modifiers, one
  can now "search :Ll" to find "Mailing lists"#10.
  The *headline*#413 format %T now also uses L and l rather than
  S and L accordingly.

  New `addrcodec'#134 subcommand `skinlist' acts like `skin'
  but stores in *!*#339 *^ERR*#341-EXIST if the address is
  one of the known "Mailing lists"#10.

- `echo'#172 family now supports `vput'#121 and *!*#339 error
  storage, offering some kind of printf(1) experience, almost.

git(1) shortlog: Steffen Nurpmeso (35)

v14.9.4 ("(5th anniversary) Marsh tit"), 2017-09-18
---------------------------------------------------

This is an update feature release but which also ships a furious
number of bug fixes, about six of which were pretty serious.  It
also applies overall trimming, and improves configuration time
compatibility on macOS.

Thanks to Alexander Harm there is now a macOS Homebrew package.

Credits, in order of commit appearance: Paul Vojta, Daniel Lublin,
Alexander Harm, Norman Ramsey, Viktor Szépe, Rich Salz,
David Čepelík, Ralph Corderoy, Stéphane Chazelas, Aharon Robbins,
Ken Hornstein.

We welcome Daniel Lublin, Alexander Harm, David Čepelík and
Stéphane Chazelas in THANKS.

NOTES, ChangeLog (packager-affine)
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

- Out-of-tree builds have become possible via the new
  make-emerge.sh script:

  $ cd /tmp && mkdir build && cd build &&
    ~/src/nail.git/make-emerge.sh &&
    make tangerine DESTDIR=.ddir

  We now have a `citron' make target which is like `tangerine' but
  does not run the tests.

- Configuration with OPT_AUTOCC honours $CC=cc. (Norman Ramsey)

- SSL/TLS configuration has been revamped (again) in order to
  support new possibilities of OpenSSL (and LibreSSL) without
  ending up and introducing more and more variables.

  Instead we now have *ssl-config-pairs*#?, a comma-separated
  list of all options.  With e.g. OpenSSL 1.1.xx this will be
  directly passed through to SSL_CONF_cmd(), so there _anything_
  can be passed, otherwise we use a builtin parser to map.
  The new *ssl-features*#? states what is supported.  E.g.:

    if [ "$ssl-features" =% +ctx-set-maxmin-proto ]
      wysh set ssl-config-pairs='\
          CipherList=TLSv1.2:!aNULL:!eNULL:@STRENGTH,\
          Curves=P-521:P-384:P-256,\
          MinProtocol=TLSv1.1'
    else
      wysh set ssl-config-pairs='\
          CipherList=TLSv1.2:!aNULL:!eNULL:@STRENGTH,\
          Curves=P-521:P-384:P-256,\
          Protocol=-ALL\,+TLSv1.1 \, +TLSv1.2'
    endif

  OpenSSL v1.1.xx also introduces an interesting and neat idea to
  centralize SSL/TLS configuration of (all) programs in a single
  file.  This can be driven via *ssl-config-file*#? and the new
  *ssl-config-module*#? variables, several entries per program
  are allowed, see *ssl-config-module*#? for an example.

  New manual section "Encrypted network communication"#13.

- Variables set or unset via -S#77 are now frozen until program
  startup is complete.

ChangeLog
^^^^^^^^^

- Historical behaviour of *askcc*#355 / *askbcc*#356 has been
  reintroduced.  (Norman Ramsey)

  A new *asksend*#357 variable will show a final header summary
  and allows reentering compose mode.  Set by default.

  POSIX mirrors *ask* onto *asksub*#359, so dropped" the former.

- `~^'#311 no longer normalizes header names to titlecase.

- We no longer generate charset=binary MIME parameters.
  This was introduced on 2013-01-02 and was i think owed to
  file(1)s -i output as i failed to find any other reference.
  (Normal Ramsey)

- *mime-alternative-favour-rich*#446 now also works for handlers
  installed via *pipe-TYPE/SUBTYPE*#471. (Viktor Szépe)

- v14.9.* series did not generate In-Reply-To: headers!

- `alias'#135 now supports high-bit bytes and semicolon.
  Expect that at some later time the input must be valid according
  to the locale, though. (Norman Ramsey)

- Combinations of *record*#497 could crash because of an
  unterminated variable function argument list. (Norman Ramsey)

- New command `readall'#240 loads an entire file into a variable.

  *signature*#517 has been obsoleted.

- `vexpr'#294 now supports negative arguments for the substring
  subcommand and adds trim, trim-front and trim-end subcommands.

- `!'#125 can be used in send mode.

- `~A'#312, `~a'#313, `~I'#322 and `~i'#323 will henceforth expand
  \t and \n only if *posix*#484 is set.
  Please use `set'#260 instead (with `wysh'#122, until v15).

- New "The mime.types files"#35 type marker: @q ("quiet").

git(1) shortlog (edited): Steffen (Daode) Nurpmeso (90)

v14.9.3 ("Crested tit nibbling sunflower seeds"), 2017-08-03
------------------------------------------------------------

This is a bugfix release but which ships some improvements, too.
It silently replaces both of v14.9.1 v14.9.2 from earlier this
week, which were broken or not entirely fixed.

Credits, in order of commit appearance: Felix Fontein, Paul Vojta,
Ralph Corderoy, Christos Zoulas, Gavin Troy, Gaetan Bisson.
Thanks, Coverity.com.

We welcome Christos Zoulas in THANKS.

Apologies to Viktor Szépe for the false spelling of his name in
the v14.9.0 announcement.
And to Gaetan Bisson for not giving credit for [14fbce97]!

NOTES, ChangeLog (packager-affine)
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

- fakeroot support was blindly taken from Debian and broken.
  (Gavin Troy, Gaetan Bisson)

- Base64 output was broken for cases which involved iconv(3).
  The data is not lost, you can read it with S-nail v14.9.0 and
  above, and save it somewhere.  I know of no other base64 decoder
  which reads those things correctly, though.  We now have tests.
  Along this i fixed an iconv(3) error which likely caused
  stateful decoding (like, e.g., for ISO-2022-JP) to fail because
  of an unnecessary reset of the iconv(3) state machine.
  Thanks to Gaetan Bisson for mentioning this issue!

ChangeLog
^^^^^^^^^

- In compose mode the MLE allows empty lines again.

- We no longer require a writable $HOME#583.  Due to false code
  flow (but but but: with correct comment) a non-writable $HOME
  entry in /etc/password (i.e., from getpwuid(3)) would lead to
  a crash.  (Felix Fontain; Ralph Corderoy)

- Two faulty string operations slipped into the IMAP code,
  resulting in a crash and a "is-same-host" test that would fail
  for IMAPS connections like `save'#257 or `copy'#157 because of an
  implicit IMAP protocol for the target of those operations (thus
  IMAP != IMAPS).  (Paul Vojta)

- The MLE tab-expansion will now automatically append a "/" if
  there is only one possible expansion and that is a directory,
  saving the user one <TAB>.  (Christos Zoulas)

  The shell expression parser had a bug regarding understood
  metacharacters (;|&), which in turn could cause an infinite loop
  in the MLE tab-expansion for, e.g., "move &9 +<TAB>", because
  the "&" would never have been stepped over.

- New `~I'#322 command escape is like `~i'#323 but does not append
  a newline.

- `localopts'#209 gained an optional second argument.
  It is now possible to specify that any macro `call'#143ed
  will have localopts enabled, and it is possible to fixate the
  setting so that it cannot be reverted.

- *@*#345 should now act completely compatible to the sh(1)ell,
  thus obsoleting my hysteric warnings in the v14.9.0 announcement.

- The `Lreply'#210, `reply'#245, `Reply'#244 series as well as
  `mail'#212 now manage the error status *!*#339.
  I.e., there are now errors like *^ERR*#341-DESTADDRREQ,
  ^ERR-NODATA, ^ERR-PERM and similar.  It is not perfect yet,
  because $DEAD#581 may have been written (with *save*#505) or not,
  for example.

  `Lreply' and `reply' have been rewritten rather completely
  indeed.  They join Reply-To: and Mail-Followup-To: dependent on
  the context (i.e., *reply-to-honour*#503, *followup-to-honour*#406,
  see "Mailing lists"#10 for the picture), and if they did, use
  this list as the receivers exclusively.  It now honours
  *recipients-in-cc*#496 even for such addressees.  (And now i wonder
  whether i should have credited Paul Vojta for that.)

  Also `Lreply' would have crashed for mails with Reply-To: but
  without *reply-to-honour*#503 set.  We now have a test.

  Note *replyto* is obsoleted in favour of *reply-to*#502.

v14.9.0 ("Long-tailed tit"), 2017-07-16
---------------------------------------

This is a major feature release which took about ~22 months (24
less two) of development to complete, and which imposed massive
changes under the hood, but also quite a lot of user visible
changes, including some **backward incompatibilities**.
As usual, "s-nail -d" will show obsoletion warnings.

We gain noticeable improvements regarding scriptability and its
reliability, but also for interactive use cases, especially
notable to users is our completely new M(ailx)L(ine)E(ditor) that
supports rather real tabulator expansion and program-mode-context-
sensitive key bindings.

We now support macros with arguments, which can be `shift'ed,
a `return' status can be used, and a `vexpr' multiplexer offers
some arithmetic and string operations.  `commandalias'es are
recursive, further command modifier prefixes, like `ignerr', give
a hand that we otherwise could not offer.  In compose-mode the new
`~^' command escape allows some message and attachment access, and
can be used, e.g., to implement things like custom headers, and
has been especially designed for scripted access via the new
*on-compose-splice* and *on-compose-splice-shell* hooks.

S-nail will move (more or less) backward-incompatibly to sh(1)ell
compatible argument quoting (documented in "COMMANDS"), and an
increasing number of commands do support this already: new ones
exclusively, some old ones have either been switched (like
`localopts'), others -- noticeably `set' -- can be switched to the
new syntax with a `wysh' command modifier prefix.  E.g.:

  ? define __xv {
    # Be careful to choose sh(1)ell-style on _entire_ line!
     localopts yes; wysh set verbose; ignerr eval "${@}"; return $?
    }
  ? commandalias call echo boo-boo
  ? commandalias xv call __xv
  ? xv list
  ? commandalias xv '\'call __xv
  ? xv list

Calling the latter `xv' for `list' will give more detailed command
information, including which kind of argument is used.

I have not managed to implement the three features i have started
this development cycle for, these are thus subject to further
development, just like wysh for message-list argument commands to
support, e.g., negation, wysh for `if' and consorts, the --
terminator to finally overcome the ridiculous requirement to quote
entire shell commands filenames for commands like `pipe.
And and and.

Credits, in order of commit appearance: Antonio Radici,
Aharon Robbins, Mike Frysinger, Predrag Punosevac, Michael Convey,
Hariskar, Rudolf Sykora, Martin Neitzel, Gavin Troy,
Salvatore Bonaccorso, Todd C. Miller, Sergey Matveev, Robert Elz,
Mantas Mikulėnas, Respiranto, Jens Schleusener, Walter Alejandro
Iglesias, Ralph Corderoy, David Levine, Lyndon Nerenberg,
Thomas Dickey, Afan, Justin Ellingwood, Ingo Schwarze,
Viktor Szépe, Gaetan Bisson, Juan RP, William Yodlowsky,
Hilko Bengen, Matthew Dillon, Colin Watson, Donald Mugnai,
Stephen Isard, Jürgen Daubert, Sven Neuhaus, trondd, Ismael Bouya,
Felipe Gasper, Paul Eggert, Dr. Werner Fink, Ken Hornstein,
Noel Chiappa, Random832, Doug McIlroy, Baptiste Daroussin,
Riccardo Ductor, Pietro Cerutti, Jörg Schilling, rain1, Xin LI.

We welcome Antonio Radici, Mike Frysinger, Predrag Punosevac,
Michael Convey, Rudolf Sykora, Todd C. Miller, Robert Elz,
Jens Schleusener, Walter Alejandro Iglesias, Thomas Dickey, Afan,
Justin Ellingwood, Viktor Szépe, Juan RP, Matthew Dillon,
Colin Watson, Donald Mugnai, Sven Neuhaus, Ismael Bouya,
Felipe Gasper, Paul Eggert, Dr. Werner Fink, Ken Hornstein,
Noel Chiappa, Random832, Doug McIlroy, Baptiste Daroussin,
Riccardo Ductor, Pietro Cerutti, Jörg Schilling, rain1, and
Xin LI in THANKS.

Apologies: Sergey Matveev.
Members of the Roff community which await progress.

NOTES, ChangeLog (packager-affine)
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

* This release brings some backward incompatibilities, outlined
  in the following.  Most users will not be affected, and we have
  added a lot of compatibility cruft, but that will vanish in v15.
  "$ s-nail -v"!

* The configuration and build system has changed.
  Packagers have received updated package files.

  o Anything which was WANT_xy before is now OPT_xy, and
    compiled-in paths and values, like PREFIX or PAGER, have
    gained a VAL_ prefix (thus VAL_PREFIX and VAL_PAGER).

    This is _not_ true for non-persistent or environmental values,
    e.g., DESTDIR, CC, etc., and also not for the overwritable
    program variables during configuration, e.g., $awk.

  o SENDMAIL -> VAL_MTA, SENDMAIL_PROGNAME -> VAL_MTA_ARGV0,
    MAILSPOOL -> VAL_MAIL.
    And NAIL -> VAL_MAILX, though this is still a lie.

  o The make system now needs config..build..install or
    all..install or tangerine (config..build..test..install).
    Some constants which some experts may want to fine-tune have
    been moved to config.h.  Usual adjustments+doc via make.rc.

  o The `build' phase can be parallelized by setting the $MAKEJOBS
    environment variable, e.g., "make MAKEJOBS=-j4 build".
    Note this variable is not tracked in the configuration.
    (Gaetan Bisson)

  o Unless DESTDIR is set an uninstallation script will be
    installed along with the rest (see INSTALL file for more).

  o Set the new OPT_CROSS_BUILD to avoid feature runtime tests,
    only compile- and link-availability will be tested.  (Juan RP)

  o VERBOSE is implemented straight, but must be given at
    configuration time in order to become honoured.
    (William Yodlowsky)

  o ADDCFLAGS / ADDLDFLAGS -> EXTRA_CFLAGS / EXTRA_LDFLAGS.

  o The LD_LIBRARY_PATH etc. building processes will skip any path
    which contains the string "fakeroot".  (Hilko Bengen)

  o We honour a set $SOURCE_DATE_EPOCH#600 environment variable to
    an extend that allows reproducible tests, which is why the
    repository gained a [test-out] branch with some expected plain
    text outputs.  (reproducible-builds.org; Colin Watson)

    The new *log-prefix*#434 variable aids in improving the
    reproducibility of error messages.

  o These are upward compatible changes.

* "make OPENSSL_API_COMPAT=0x10100000 all" should work.

* Internal and environment variables are now explicitly _defined_
  and _tracked_ after variable handling has been rewritten
  completely.  Notes:

  o This means that, e.g., "$ password=NOT_SECRET s-nail" will
    **NOT** work no more, since *password*#469 is an internal
    variable!

  o But if you do, e.g., "? set TMPDIR=~/tmp", then this will
    also be reflected in the program environment (it is an
    environment variable) and thus affect child processes.

  o Therefore we no longer have `setenv' and `unsetenv'.

  o To integrate any other environment variable transparently
    into our variable management, the new command `environ'#180
    needs to be used, e.g., "? environ set NEWVAR=value" or
    "? environ link EXISTINGVAR".

- -H#66 and -L#69 have been decoupled:
   it used to be -e#63 -L#69 instead!

- *NAIL_{HEAD,TAIL}* have been obsoleted in favour of
  *message-inject-head*#442 and *message-inject-tail*#443.

  *NAIL_HIST{FILE,SIZE}* have been obsoleted in favour of
  *history-file*#416 and *history-size*#419.

  *NAIL_EXTRA_RC* has been obsoleted in favour of
  *mailx-extra-rc*#437.

  *batch-exit-on-error* has been obsoleted by *errexit*#396, which
  works just like the POSIX sh(1)ell "set -e" construct; the
  `ignerr'#117 command modifier (`-' for command escapes in compose
  mode, and see below) can be used to ignore command errors even
  then.  (This will remain even if we at some later time will
  support at least some of the sh(1) constructs which "swallow"
  failures with set -e.)

  *bsdannounce* is obsolete, the feature is integrated in
  *header*#412 as this is much more useful.  (This is however also
  dependent upon the also new but well-known $POSIXLY_CORRECT#598
  <> *posix*#484, but that is just how it is; these affect more
  behaviour, and increasing.)

- Colour support has been changed backward in- and upward (from
  user interface side) compatibly, see the manual section
  "Coloured display"#18.

  + New commands: `colour'#152 and `uncolour'#153.
    You can define context-sensitive, terminal-capability-
    sensitive settings, e.g.:

      if terminal && [ "$features" =% +colour ]
        colour iso  view-header ft=bold,fg=magenta,bg=cyan
        colour 256  view-header ft=bold,fg=208,bg=230 subject,from
        colour mono view-header ft=bold
        colour mono view-header ft=bold,ft=reverse subject,from
      endif

  + The variable *colour-pager*#382 defines whether colour and font
    attribute sequences should be generated when viewing something
    in $PAGER#596.

  + Set the variable *colour-disable*#381 to turn colour off
    without affecting established settings.

  + It is deduced via termcap(5) (see below) whether the terminal
    supports colors, e.g., "$ s-nail -Stermcap=Co#256".
    This is also true if we don't have termcap support.

  + Support for 256-colour terminals. (Gavin Troy)

- `source'#272 series support shell pipes if the last character
   of the "filename" ends with a vertical bar |, e.g.,

      ? source 'gpg -qd ~/.s-nailrc-private.gpg |'

- Shell pipes are also supported as targets for `move'#222,
  `copy'#157 etc., yet unfortunately not with via a sh(1)ell token
  parser, so that the target still has to be a single argument.

      ? copy . '| cat; echo huhu'

- Support for custom headers via the new `~^'#311 compose-mode
  command escape and in addition, or alternatively, with the
  internal variable *customhdr*#386, which also can be covered by
  `localopts'#209.  (Sergey Matveev)

  + Support of $ORGANIZATION has been dropped.

  + Command escape `~e'#317 supports _any_ header.

  + Command escape `~^'#311 supports _any_ header.

- New -:#53 command line option can be used to more easily select
  which startup files should be loaded, e.g., -:/ loads none.
  (Robert Elz)

- `account'#132s and *folder-hook*#403s now have `localopts'#209
   enabled by default.

- A first simple form of compose-mode hooks has been implemented:
  *on-compose-enter*#462, *on-compose-leave*#463 and
  *on-compose-cleanup*#461 can be set to macros which get invoked
  at appropriate times.
  For the `resend'#249 series there is *on-resend-enter*#467 and
  *on-resend-cleanup*#466: this is very likely to change once
  true message access is possible even in this mode.

  An even more powerful mechanism is available via the also new
  *on-compose-splice*#464 and *on-compose-splice-shell*#465 hooks.
  These are executed in child processes and communicate with the
  parent via their standard input and output, and therefore can
  do anything and act as if they were the user.

  `localopts'#209 are enabled and cannot be disabled (and extend
  until the message is sent).
  (Jens Schleusener, Rudolf Sykora)

    ? set on-compose-splice=ocs
    ? define ocs {
      read ver
      echo Splice protocol version is $ver
      echo '~^header list'
      read hl; vput vexpr es substring "${hl}" 0 1
      if [ "$es" != 2 ]
        echoerr 'Failed to read header list, bailing out'
        echo '~x'
      elif [ "$hl" @i!% ' cc' ]
        echo '~^header insert cc Diet is your <mirr.or>'
        read es; vput vexpr es substr "${es}" 0 1
        if [ "$es" != 2 ]
          echoerr 'Failed to insert Cc:, bailing out'; echo '~x'
        end
      end
    }

- "The .netrc file"#37

  + gained support for comments.
    (Walter Alejandro Iglesias, Ralph Corderoy)

  + `netrc'#225 now has a "load" subcommand.

  + the new *netrc-pipe*#456 obsoletes OPT_AGENT and
    *agent-shell-lookup*, and can be used to load an encrypted
    .netrc file, e.g.:

      ? set netrc-lookup netrc-pipe='gpg -qd ~/.netrc.gpg'

    I.e., this is in usual .netrc syntax and thus possibly much
    nicer than saying "? source 'gpg -qd ~/.credentials.gpg |'".

- termcap(5) / terminfo(5) support has been changed backward in-
  and upward (from user interface side) compatibly, please read
  "On terminal control and line editor"#17.

  + OPT_TERMCAP is by default enabled.
    The new, by default enabled, configuration option
    OPT_TERMCAP_VIA_TERMINFO can be used to (try to) use
    terminfo(5) instead.

  + The variable *termcap*#549 can be used to freely define or
    override terminal capabilities, and *termcap-disable*#551 will
    disable interaction with the chosen library, leaving only
    *termcap* in charge.

    To use the so-called ca-mode on supporting terminals,
    effectively turning S-nail into a fullscreen application,
    *termcap-ca-mode*#550 must be set.

  + The built-in line editor has been rather completely rewritten
    to be the Mailx-Line-Editor (OPT_MLE, default yes), and
    supports wide glyphs (if possible), infinite line lengths
    (2 GB) and more.  Tabulator expansion is no longer an option
    (but needs fnmatch(3)).

  + Optionally (OPT_KEY_BINDINGS, default yes) it has become
    possible to freely define key bindings for the MLE via the new
    `bind'#141 and `unbind'#142 commands.  These key bindings can
    make use of termcap(5) and/or terminfo(5) names.  The MLE will
    install a set of default bindings (unless there is a set
    *line-editor-no-defaults*#433), more so with OPT_TERMCAP,
    i.e., try "? bind*".

    Sufficient support provided, one can now, e.g., type "p " and
    then collect the message numbers to type, scrolling forward
    and backward via key-bindings, without losing the line
    content, then commit the final line.

  + OPT_EDITLINE and OPT_READLINE support have been dropped.
    The new MLE should not miss anything.  Does it?
    Tip: in an UTF-8 locale try "? !touch /tmp/hall{,öchen}" and
    then autocomplete that: once, then ^Q, and again.

- `source'#272 can be used in `call'#143ed macros.
  What sounds so innocent replaced an entire machinery and got rid
  of a brilliant idea of Kurt Shoens from the 70s, but which never
  worked with Nail/Heirloom extensions, namely macros, and in the
  right order.
  Accompanying this -X#83 can (dig multiline arguments and can) be
  used to define macros and run them etc.  Should work:

    $ s-nail -X'define x {' -Xversion -Xx -X'}' -X'call x'
    $ s-nail -X'source \' -X'"echo version|"' -Xx

  Macros can be `undefine'#162d from within themselves, and re-
  `define'#161d.  It is still not possible to define macros
  from within macros, and/or have inner macros, not to talk
  about local scoping or anything more sophisticated such.

- -u#80 / $LOGNAME#589 ($USER) handling has been redefined,
  and "-u USER" is now exactly the same as "-f %USER", and
  $LOGNAME (and $USER) is actively set to the active user.  (Afan)

  $LOGNAME#589 is POSIX standardized and henceforth used and
  preferred over $USER, which came from BSD.  (Todd C. Miller)

- In the future (at least non-message-list) argument handling will
  be changed backward-incompatibly to be sh(1)ell compatible (and
  thus POSIX standardized), see "Shell-style argument quoting"#23.
  New commands use it already today (`bind'#141, `colour'#152,
  `headerpick'#200), some others (most importantly, `set'#260) can
  be forced to do so via the new `wysh'#122 command prefix, as in:

    ? wysh set message-inject-tail=$'\n--steffen'
    ? bind base $'\cA,\x61' 'echo control-A and small a'

- We now actively manage *umask*#570: 0077 by default, but an
  empty string will use the setting that is active upon startup.
  Just like changes to (known) environment variables, this setting
  will also be inherited by any child process.
  (Walter Alejandro Iglesias)

- Anything SENDMAIL / *sendmail*-ish has been renamed to *mta*#450,
  *mta-arguments*#451, *mta-no-default-arguments*#452 and
  *mta-argv0*#454.

  The reason is that in v15 we won't even have *smtp*: it is just
  another form of MTA, and thus obsolete by itself.
  Note that *mta-arguments* is now parsed via the shell-token
  parser, so the following ends up exactly as desired.

    ? set mta-arguments='-t -X "/tmp/my log"'

  For now we support a hack that understands a file:// URL in
  *mta*, too, but that is also the default if there is no protocol.
  E.g.: "? set mta=smtp://a:b@xy.z"

- The "spamd" *spam-interface*#536 is obsolete.  I haven't tested
  it since my main machine died, it is error prone since it assumes
  internals of the spamassassin wire protocol, and there never was
  a speed improvement over "spamc".  (However it could react upon
  the "is-spam" state of a message, which "spamc" doesn't allow.)

- The new *inbox*#427 variable will henceforth be looked up when
  searching for a primary system mailbox (as in "? File %"),
  followed by the usual $MAIL#590 and compile-time defined local
  mailspool search.  (Stephen Isard, Jürgen Daubert)

- The semantic of -a#55 and `~@'#309 have been changed, and both
  commands now use the same syntax:

    -a file[=input-charset[#output-charset]]

- New "failinvaddr" keyword for *expandaddr*#398.

- We finally "can" the so-called (by myself) "Dr. Problem" (a bit):
  (Dr. Werner Fink)

    $ </dev/null s-nail -d:/ -sTrödler 'Dr. D. Iet <z@a.k>' 2>&1 |\
      grep To:
    s-nail: >>> To: "Dr. D. Iet" <z@a.k>

  This can be done via the new `addrcodec'#134, too, note this
  supports multiple modes (and the `vput'#121 command modifier):

    $ echo 'addrcodec e Dr. Diet <to@fu.soj> Curd' | s-nail -#:/
    "Dr. Diet Curd" <to@fu.soj>

- All commands with the string "codec" in their name use different
  argument quoting, namely none at all, please read
  "Raw data arguments for codec commands"#25.
  This means that `urlcodec'#290 (and `imapcodec'#628) has
  slightly changed semantics.
  And, while here: there is a new `shcodec'#262, too.

- We gained "Command modifiers"#21: `\'#116 (avoid expansion of
  `commandalias'#154es), `vput'#121 (store result in variable),
  `ignerr'#117  (ignore an error of the following command, even
  if the new *errexit*#396 is set), `wysh'#122 (use shell-style
  arguments).

    $ echo 'vput cwd resvar;echo $resvar' | s-nail -#:/
    /home/steffen/src/nail.git

  And the usual sh(1) stuff: `return'#255, `shift'#266, `eval'#182,
  plus a `xcall'#298 stack-avoidance optimization (to be used in
  place of a `call'#143 which would be the last called command).
  And an "expr(1) like thing", yet simple, `vexpr'#294.

    $ echo 'vexpr + 1 2' | s-nail -#:/
    00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000011
    03 | 0x3 | 3
    $ echo 'vput vexpr resvar + 1 2;echo $resvar' | s-nail -#:/
    3

  We actually start walking (*?*#338, *^*#340).

    ? vput vexpr res regex 'bananarama' 'Bana(.+)' '\$1\$0'
    ? echo $?/$^ERRNAME :$res:
    1/NODATA ::
    ? vput vexpr res iregex 'bananarama' '(.+)rama' '\$1\$0'
    ? echo $?/$^ERRNAME :$res:
    0/NONE :bananabananarama:

  The command `vpospar'#295 can be used to manage the stack of
  positional parameters, i.e., much like "set --".
  It also offers the possibility to save and restore the stack to
  and from variables.  Etc.

  Btw., to contact the maintainer (make.rc variables
  VAL_CONTACT_WEB and VAL_CONTACT_MAIL):

    ? echo $contact-web; eval mail $contact-mail

- `if'#206 no longer performs automatic number conversion, we
  use the explicit -lt, -gt etc. syntax of the sh(1).
  Note: `if' will change to be almost identical to sh(1) if(1),
  so please ensure proper test bracketing, even if it is less
  convenient.

  Moreover, the default string comparison mode has changed to
  case-sensitive, just like in the shell.  This is because in the
  future this crux with trigger characters will vanish and `if'
  etc. will simply slurp in already expanded shell tokens, it will
  act like the shell in that respect.  We have modifiers, though,
  yet only "@i" for case-insensitivity, also for regex matches:

    LC_ALL=C
    i=`LC_ALL=C.utf8 s-nail -:/ -# -X '
       \define cset_test {
          \if [ "${ttycharset}" @i=% utf ]
             \echo $LC_ALL
             \xit 0
          \end
          \if [ "${#}" -gt 0 ]
             \wysh set LC_ALL=${1}
             \shift
             \eval xcall cset_test "${@}"
          \end
          \xit 1
       }
       \call cset_test C.UTF-8 POSIX.utf8 POSIX.UTF-8 \
          en_EN.utf8 en_EN.UTF-8 en_US.utf8 en_US.UTF-8
   '`
   [ $? -eq 0 ] && UTF8_LOCALE=$i

  Please note the `eval' in 'eval xcall cset_test "${@}".  This is
  a difference of S-nail/mailx and the sh(1)ell that will remain,
  as documented in "COMMANDS"#20: whereas the shell implements
  a language and performs standardized expansions on the line
  until finally the command is called, S-nail will decide the type
  of command line parsing dependent on the seen command, and will
  then perform a single expansion.  Therefore "${@}" will expand
  to multiple arguments if $# is greater 0, but it will expand to
  the empty string otherwise, which is not furtherly expanded away
  since it is meaningless like it is in the shell: therefore $#
  will be 1 (the empty string) not 0.

- Using an explicit proto:// prefix should get you the desired
  thing apart of *newfolders*#457, e.g.:

    ? File maildir:///tmp/x.mdir
    ? copy * file:///tmp/x.mbox

- New variable *record-files*#498 can be set to extend the meaning
  of *record*#497.  *record-resent*#499 was there already.

- New variable *ifs*#423 acts a bit like the sh(1)ell's $IFS for,
  e.g., the new `read'#239 command.

  There is a `readctl'#241 command which can be used to manage
  the active channel used by `read'#239.

- The `~' alias for `call'#143 is gone.

- `mimetype'#214 only allows specification of a single type per
  call, on the other hand no need to quote that.

- `mimeview'#218 must now be used explicitly to look at any
  non-text MIME part, for normal display etc. purposes we only
  support "copiousoutput"#615 MIME handlers.

- New *socks-proxy*#535 can be used to proxy all network traffic
  over a SOCKS5 proxy.  (Gaetan Bisson)

ChangeLog
^^^^^^^^^

- The manual has seen another major overhaul, all the variables
  are now documented in a single, sorted list, and many
  clarifications should have been added.  I hope it has become
  a better read.
  (Predrag Punosevac, Michael Convey, Hariskar, Rudolf Sykora,
  Respiranto, Thomas Dickey, Donald Mugnai)

- To support RFC 1524 a.k.a. .mailcap files (see below) many
  "trigger"-characters have been added for *pipe-TYPE/SUBTYPE*#471,
  which may (rarely) affect existing values.
  The .mailcap support itself is not yet implemented.

- *mime-counter-evidence*#447 gained bit 4 (perform proper in-depth
  content inspection as necessary; set to 0xE for all bits).
  (Aharon Robbins)

- Maildir paths are now created recursively as necessary.
  (Justin Ellingwood)

- -M#70 and -m#71 options have been added to enforce a special
  send mode that will flag standard input / the given file with
  the specified / detected MIME 'Content-Type:'.  This can be used
  to directly send, e.g., HTML log output.
  (Viktor Szépe, Ralph Corderoy)

- Disallow symlinks on writable files.  Note this requires
  O_NOFOLLOW support for the operating-system-call open(2), but
  which has been standardized a long time ago.
  (Matthew Dillon)

- `retain'#254, `ignore'#207 etc. now differentiate in between
  From (the From: header) and From_ (the MBOX ident).

  In fact we now have a new `headerpick'#200 command which
  is a multiplexer for all retain and ignore lists used, call it
  without arguments to see the current setting(s).
  In v15 only `headerpick' and the standard-imposed wrappers
  `retain' and `ignore' will remain, all other wrappers will
  vanish.  Regular expressions can now be used if available:

    ? headerpick
      headerpick type retain blahblahblah cc date from \
        mail-followup-to message-id openpgp reply-to subject to \
        user-agent
      #headerpick type ignore currently covers no fields
      #headerpick save retain currently covers no fields
      headerpick save ignore '^Original-.*$' '^X-.*$' '^DKIM.*$'
      headerpick forward retain cc date from list-id \
        mail-followup-to openpgp reply-to subject to
      #headerpick forward ignore currently covers no fields

- `top'#282 has been rewritten completely, `Top'#281 is new.
  It uses a built-in set of retain/ignore headers, but it is
  possible to register a custom set via `headerpick'#200.
  Also, *toplines*#566 has been extended a bit and the new
  *topsqueeze*#567 variable may pimp your `top' experience.

    ? headerpick top retain add subject
    ? top
    [-- Message  1 -- 87 lines, 4791 bytes --]:
    Subject: Re: I can't dist to myself

    I wrote:
        3.22. bounce_delivered

- `features' has been dropped, `version'#293 extended.

- The *prompt*#486 handling has changed: we lost the capability to
  expand \?, \@ and \$, instead new "private" variables *?*#338,
  *account*#349, *mailbox-resolved*#436 and
  *mailbox-display*#435 have been introduced, and the prompt
  is completely shell expanded (thus twice with `wysh' or in v15),
  as if dollar-single-quote quoted.  We do support the reverse-
  solidus escaped bracket notation for embedding characters which
  should not be counted when calculating the width of the prompt.
  The `colour'#152 command has a slot for the prompt colour.
  We gained *prompt2*#487 as a second level prompt.

    ? var prompt
    wysh set \
      prompt='?\${?}!\${!}[\${account}#\${mailbox-display}]? '

- The filename "-" can be used as a receiver, e.g.,

    $ echo Hey,\ you | s-nail -:/ -Sexpandaddr -sUB -

- The -s#78 command line option, the `~s'#331 command escape
  as well as the corresponding slots of `~^'#311 will actively
  strip [\r\n] from their value (Debian #419840).

- New `read'#239 and `echoerr'#173 commands, mostly for
  *on-compose-splice*#464.
  But also `echon'#174 and `echoerrn'#175, which do not write
  a trailing newline.

- New variable *r-option-implicit*#495 may be helpful to those
  who regulary need the functionality of the -r#76 command
  line option.  (Felipe Gasper, Martin Neitzel)

- By using new "pseudo-URLs" one can automatize the use of S/MIME
  keys / (certificates / intermediate include certificates) with
  passwords.  E.g., to drive bob@exam.ple, set
  *smime-sign-cert-bob@exam.ple* to the private key / certificate
  pair as usual, the password lookup will then be performed for
  bob@exam.ple.smime-cert-key, bob@exam.ple.smime-cert-cert and
  bob@exam.ple.smime-include-certs.
  Like this the password can be stored in an encrypted .netrc file
  when *netrc-lookup*#455 and *netrc-pipe*#456 are set, or it may
  be stored in an encrypted resource file that has been loaded via
  `source'#272 as a simple *password*#469 variable.

  Note that the prompting that happens as a last resort of
  password lookup will still interfere with a possibly running
  $PAGER#596 instance, dependent on the setting of *crt*#385, of
  course.  Proper job control handling and recognizing that we are
  running $PAGER when doing that prompt is a TODO for v15.  Sorry.

- Some commands, like `set'#260, `help'#203, `list'#208,
  `mlist'#216 etc., now react upon the setting of *verbose*#573
  and(/or) *debug*#389.

- `write'#297 uses iconv(3) as appropriate.

- *mbox-rfc4155*#439 has first been dropped, and was then
  reintroduced with different semantics.  Because, it can be
  helpful if a messed up MBOX is read, in which case we henceforth
  will warn you and point you to this:

    ? define mboxfix {
      \localopts yes; \wysh set mbox-rfc4155;\
        \wysh File "${1}"; \eval copy * "${2}"
    }
    ? call mboxfix /tmp/bad.mbox /tmp/good.mbox

  P.S.  Here you see how weird the current thing still is, in v15:

    ? define mboxfix {
      localopts yes; set mbox-rfc4155; File "${1}"; copy * -- "${2}"
    }

  And also in v15 we will not apply (proper) so-called MBOXO
  quoting, but instead (simply MIME) re-encode mail messages.

- `call_if'#144 is new and, different to "? ignerr call", silent
  and not messing with the return status.

- The new *smime-ca-flags*#521 and *ssl-ca-flags*#? can be used
  to fine-tune X509_STORE_set_flags(3) a.k.a the X509 CA
  certificate verification.

    ? set ssl-ca-flags=partial-chain
    ? wysh set smime-ca-flags="${ssl-ca-flags}"

  Also, *ssl-curves*#? for TLSv1.3.

- Socket connections use TLS S(erver)N(ame)I(ndication) as
  appropriate (RFC 7817).

- `alternates'#137 checks arguments and supports `vput'#121.
  It by default no longer replaces but appends alternates, unless
  *posix*#484 mode is active.  There is a new `unalternates'#138
  command to remove alternates.

- A new `charsetalias'#147 command.  (Pietro Cerutti, mutt#3925)

- New commands `filetype'#187 and `unfiletype'#188: in the future
  we will no longer know any builtin filetypes, in fact we already
  simulate .gz etc. via the new mechanism as necessary:

    ? filetype \
       bz2 'bzip2 -dc' 'bzip2 -zc' \
       gpg 'gpg -d' 'gpg -e' \
       gz 'gzip -dc' 'gzip -c' \
       xz 'xz -dc' 'xz -zc' \
       zst 'zstd -dc' 'zstd -19 -zc' \
       zst.pgp 'gpg -d | zstd -dc' 'zstd -19 -zc | gpg -e'

- `~<'#306 now offers a "- [HERE-delimiter]" mode for pasting etc.
  (Ralph Corderoy)

- `exit'#183 and `quit'#238 take an optional exit status.
  (That is not fixated yet, though.)

- We have a useful -h / --help output.  (Doug McIlroy)

- *encoding* obsoleted in favour of new *mime-encoding*#448, which
  now defaults to base64.

- *allnet*#351 now works (broken since nail 10.00, 2002-09-29).

Appendix
^^^^^^^^

The complete changelog of commits in between two versions OLD and
NEW can be inspected by using the git(1) `log' command:

  $ git log --reverse --topo-order --abbrev-commit OLD..NEW
  # Only topic branch headers (--no-merges for content commits only):
  $ git log --oneline --reverse --topo-order --merges OLD..NEW
  # Same, but truly accessible:
  $ git log --oneline --reverse --topo-order --merges --parents OLD..NEW |
    while read c1 c2 c3 c4 c5 c6; do
      printf "%-24s: \$ git log --oneline --no-merges %s ^%s\n" \
        "${c6}" "${c1}" "${c2}";
    done

Entries for releases before v14.9.0 have been cut off and can be
found in the git(1) repository:

  v14.8.0 - v14.8.16: $ git show v14.8.16:NEWS
  v13     - v14.8.5 : $ git show v14.8.5:NEWS
  9.0     - 12.5    : $ git show heirloom:ChangeLog

Also accessible via HTTPS?, just replace X.Y.Z accordingly:

  \https?://git.sdaoden.eu/cgit/s-nail.git/tree/NEWS?h=vX.Y.Y

For even older releases you need to look into the [timeline]
branch, but no changelog has been administrated for them.

# s-tm-mode
